#ifdef UNIX5
#ifndef lint
static char version_id[] = "%Z% File : %M% %E%  %U%  Version %I% Copyright (C) 1992/93 Schweikardt Andreas";
#endif
#endif 

/*******************************************************************************
*									       *
*									       *
*			SEARCH STRATEGIES ON GRAPHS			       *
*									       *
*									       *
*	Copyright (C) 1992/93 Andreas Schweikardt			       *
********************************************************************************




	File	:	%M%

	Date	:	%E%	(%U%)

	Version	:	%I%

	Author	:	Schweikardt, Andreas



Portability

	Language		:	C
	Operating System	:	Sun-OS (UNIX)
	User Interface (graphic):	
	Other			:	GraphEd & Sgraph


********************************************************************************


Layer   : 	

Modul   :	


********************************************************************************


Description of %M% :




********************************************************************************


Functions of %M% :



*******************************************************************************/


/******************************************************************************
*                                                                             *
*			standard includes				      *
*                                                                             *
*******************************************************************************/

/******************************************************************************
*                                                                             *
*			gui includes    	 			      *
*                                                                             *
*******************************************************************************/

/******************************************************************************
*                                                                             *
*			GraphEd & Sgraph includes			      *
*                                                                             *
*******************************************************************************/

#include <sgraph/std.h>
#include <sgraph/sgraph.h>
#include <sgraph/slist.h>
#include <sgraph/graphed.h>


/******************************************************************************
*                                                                             *
*			local includes		 			      *
*                                                                             *
*******************************************************************************/

#include <search/search.h>
#include <search/algorithm.h>
#include <search/control.h>
#include <search/move.h>
#include <search/error.h>


/******************************************************************************
*                                                                             *
*			local defines 		 			      *
*                                                                             *
*******************************************************************************/

/******************************************************************************
*                                                                             *
*			local macros  		 			      *
*                                                                             *
*******************************************************************************/

/******************************************************************************
*                                                                             *
*			local types		 			      *
*                                                                             *
*******************************************************************************/

/******************************************************************************
*                                                                             *
*			local functions					      *
*                                                                             *
*******************************************************************************/

/******************************************************************************
*                                                                             *
*			global variables				      *
*                                                                             *
*******************************************************************************/

/******************************************************************************
*                                                                             *
*			local variables					      *
*                                                                             *
*******************************************************************************/



/******************************************************************************
*                                                                             *
*                                                                             *
*                       local functions		                              *
*                                                                             *
*                                                                             *
******************************************************************************/

/******************************************************************************
*                                                                             *
*                                                                             *
*                       global functions		                      *
*                                                                             *
*                                                                             *
******************************************************************************/


void	CliqueSearch(Sgraph graph, Method method)
{
	Slist	clique, elt;
	Snode	node;
	int	count = 0;
	int	mindeg = COnodes(),
		mincount = 0;

	extern Slist 	M_find_max_clique();

	clique = M_find_max_clique( graph );

	for_slist( clique, elt )
	{
		count++;
	} end_for_slist( clique, elt )

	if ( count > 0 && method == METHOD_MIXED_SEARCH )
	{
		count--;
	}
	else if ( ( count == 2 || count == 3 ) && method == METHOD_EDGE_SEARCH )
	{
		count--;
	}


	for_all_nodes( graph, node )
	{
		mincount = DegreeNode( node );
		if ( mincount < mindeg )
		{
			mindeg = mincount;
		}
	} end_for_all_nodes( graph, node )

	if ( method != METHOD_MIXED_SEARCH )
	{
		if ( method == METHOD_EDGE_SEARCH && mindeg >= 1 && mindeg <= 2 )
		{ }
		else
		{
			mindeg++;
		}
	}

	if ( count > mindeg )
	{

		COsetHiddenMaxSearchers( count );
		COsetMaxSearchers( count );

	}
	else
	{
		COsetHiddenMaxSearchers( mindeg );
		COsetMaxSearchers( mindeg );
	}
	COnotifyInfo( "Lower bound !" );
}

/******************************************************************************
*		       [EOF] end of file %M% 
******************************************************************************/
